#!/usr/bin/env python
# -*- coding: utf-8 -*-
# GUI generated with help of wxGlade 0.6.3 on Thu Jan 14 23:40:49 2010
# Author is grateful to people who constantly help in developing of the LinXTL:
# Michel Simard; Theirry Moris; Hein Schaper; Government of Canada and University of Montreal for financial support 
# of my Ph.D theses.
# License: GPL
#GNU GENERAL PUBLIC LICENSE
#Version 3, 29 June 2007
#Copyright (C) Denis Spasyuk
#Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed.
#Preamble
#The GNU General Public License is a free, copyleft license for software and other kinds of works.
#The licenses for most software and other practical works are designed to take away your freedom to share and change the works. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change all versions of a program--to make sure it remains free software for all its users. We, the Free Software Foundation, use the GNU General Public License for most of our software; it applies also to any other work released this way by its authors. You can apply it to your programs, too.
#When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for them if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs, and that you know you can do these things.
#To protect your rights, we need to prevent others from denying you these rights or asking you to surrender the rights. Therefore, you have certain responsibilities if you distribute copies of the software, or if you modify it: responsibilities to respect the freedom of others.
#For example, if you distribute copies of such a program, whether gratis or for a fee, you must pass on to the recipients the same freedoms that you received. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.
#Developers that use the GNU GPL protect your rights with two steps: (1) assert copyright on the software, and (2) offer you this License giving you legal permission to copy, distribute and/or modify it.
#For the developers' and authors' protection, the GPL clearly explains that there is no warranty for this free software. For both users' and authors' sake, the GPL requires that modified versions be marked as changed, so that their problems will not be attributed erroneously to authors of previous versions.
#Some devices are designed to deny users access to install or run modified versions of the software inside them, although the manufacturer can do so. This is fundamentally incompatible with the aim of protecting users' freedom to change the software. The systematic pattern of such abuse occurs in the area of products for individuals to use, which is precisely where it is most unacceptable. Therefore, we have designed this version of the GPL to prohibit the practice for those products. If such problems arise substantially in other domains, we stand ready to extend this provision to those domains in future versions of the GPL, as needed to protect the freedom of users.
#Finally, every program is threatened constantly by software patents. States should not allow patents to restrict development and use of software on general-purpose computers, but in those that do, we wish to avoid the special danger that patents applied to a free program could make it effectively proprietary. To prevent this, the GPL assures that patents cannot be used to render the program non-free.
from __future__ import print_function
import wx
import sys, os
import webbrowser
import shutil 
global ossystem
ossystem=sys.platform

class Options(wx.Dialog):
    def __init__(self, parent, version, fnoe, dirname, path, text):
        wx.Dialog.__init__(self, parent, style = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.THICK_FRAME)
        self.version = version
        self.fnoe=fnoe
        self.dirname=dirname
        self.path=path
        self.text=text
        userdir=os.path.join(self.path,"user")
       # print"opend=True options"
        listusers=[] # list of user data for cif file 
        listdev=[]
        listext=['.cif']
        for file in os.listdir(userdir):
            for i in listext:
                if file.endswith(i):
                    listusers.append(file)
        for file in os.listdir(os.path.join(userdir,"device")):
                if file.endswith(".dev"):
                    listdev.append(file)  
        list1=[]
#        dict=["_exptl_crystal_colour", "_exptl_crystal_size_min","_exptl_crystal_size_mid", "_exptl_crystal_size_max", 
#        "_chemical_formula_moiety", "_exptl_crystal_description","_symmetry_space_group_name_H-M ", "_diffrn_ambient_temperature", 
#        "_exptl_absorpt_correction_T_min", "_exptl_absorpt_correction_T_max", "_refine_ls_hydrogen_treatment", "_symmetry_cell_setting"]
        if not os.path.exists(os.path.join(self.dirname,"lin.tmp")):
            lintmp=open(os.path.join(self.dirname,"lin.tmp"), 'w')
            lintmp.writelines("'Yellow'\n" + listdev[0]+"\n"+"0")
            lintmp.close() 
        pcfr_dict={}
        with open(fnoe+".pcf", 'r') as pcfr:
            for entry in pcfr:
                if not len(entry.strip())==0:
                    try:
                       line=entry.partition(" ")
                       print(line)
                       pcfr_dict[line[0]]=line[2].strip().replace('\n','')
                    except IndexError:
                        pass
        self.pcfr_dict=pcfr_dict
        #################reading cif file for input
        if os.path.exists(os.path.join(self.dirname,fnoe+".cif"))==True:
            ciff=open(fnoe+".cif", 'r')
            ciffr=ciff.readlines()
            for lines in ciffr:
                if lines.startswith("_cell_formula_units_Z"):
                   zval=self.zval=lines.replace("_cell_formula_units_Z", "").strip()
            ciff.close()
        else:
            wx.MessageBox(fnoe+'.cif file was not found', 'Error', 
            wx.OK | wx.ICON_INFORMATION)
        mformula=self.mformula=hydrogen=self.hydrogen=cells=self.cells=spaceg=self.spaceg= temper=self.temper=abctmin=self.abctmin=abctmax=self.abctmax= min=self.min=mid=self.mid=mid=self.mid=max=self.max=shape = self.shape="?"   
     
        try:
            mformula=self.mformula=(pcfr_dict['_chemical_formula_moiety']).strip().replace("'","")
        except KeyError:
           pass
        try:
           hydrogen=self.hydrogen=(pcfr_dict['_refine_ls_hydrogen_treatment']).strip().replace("'","")
        except KeyError:
           pass
        try:
            cells=self.cells=(pcfr_dict['_symmetry_cell_setting']).strip().replace("'","")        
        except KeyError:
           pass
        try:
            spaceg=self.spaceg=(pcfr_dict['_symmetry_space_group_name_H-M']).strip().replace("'","") 
        except KeyError:
           pass
        try:
            temper=self.temper=(pcfr_dict['_diffrn_ambient_temperature']).strip().replace("'","")
        except KeyError:
           pass
        try:
            abctmin=self.abctmin=(pcfr_dict['_exptl_absorpt_correction_T_min']).strip().replace("'","")
        except KeyError:
           pass
        try:
            abctmax=self.abctmax=(pcfr_dict['_exptl_absorpt_correction_T_max']).strip().replace("'","")
        except KeyError:
           pass
        try:
            min=self.min= (pcfr_dict['_exptl_crystal_size_min']).strip().replace("'","")
        except KeyError:
           pass
        try:
            mid=self.mid=(pcfr_dict['_exptl_crystal_size_mid']).strip().replace("'","")
        except KeyError:
           pass
        try:
            max=self.max=(pcfr_dict['_exptl_crystal_size_max']).strip().replace("'","")
        except KeyError:
           pass
        try:
            shape = self.shape = (pcfr_dict['_exptl_crystal_description']).strip().replace("'","")
        except KeyError:
           pass
            
                         

        self.sizer_14_staticbox = wx.StaticBox(self, -1, "ABC_T_min")
        self.sizer_15_staticbox = wx.StaticBox(self, -1, "ABC_T_max")
        self.panel_2 = wx.Panel(self, -1)
        self.sizer_6_staticbox = wx.StaticBox(self, -1, "Colour")
        self.sizer_7_staticbox = wx.StaticBox(self, -1, "Crystal Shape")
        self.sizer_8_staticbox = wx.StaticBox(self, -1, "Z")
        self.sizer_9_staticbox = wx.StaticBox(self, -1, "Crystal size x ,mm")
        self.sizer_10_staticbox = wx.StaticBox(self, -1, "y, mm")
        self.sizer_11_staticbox = wx.StaticBox(self, -1, "z, mm")
        self.sizer_12_staticbox = wx.StaticBox(self, -1, "Space Group H-M")
        self.sizer_13_staticbox = wx.StaticBox(self, -1, "Hydrogen Treatment")
        self.sizer_16_staticbox = wx.StaticBox(self, -1, "Machine Type")
        self.sizer_17_staticbox = wx.StaticBox(self, -1, "Moiety Formula")
        self.sizer_18_staticbox = wx.StaticBox(self, -1, "Cell Setting")
        self.sizer_19_staticbox = wx.StaticBox(self, -1, "Temperature, K ")
        self.sizer_3_staticbox = wx.StaticBox(self, -1, "Parameters ")
        self.sizer_4_staticbox = wx.StaticBox(self, -1, "Users")
        self.list_box_1 = wx.ListBox(self, -1, choices=listusers)
        ##################tmp###################################       
        lintmp=open(os.path.join(self.dirname,"lin.tmp"), 'r')
        lintmpr=lintmp.readlines()
        self.lastposition1=lintmpr[0].replace('\n','').replace('\r','')
        self.lastposition2=lintmpr[1].replace('\n','').replace('\r','')
        listbsel=lintmpr[2]
        lintmp.close()
        if len(listusers)==1:
           self.list_box_1.SetSelection(0)
        elif len(listusers)>=int(listbsel):
           self.list_box_1.SetSelection(int(listbsel))

        self.text_shape=wx.TextCtrl(self, -1, self.shape)
        self.text8= wx.TextCtrl(self, -1,  self.cells)
        self.text1= wx.TextCtrl(self, -1,  self.zval)
        self.text2= wx.TextCtrl(self, -1,  self.min)
        self.text3= wx.TextCtrl(self, -1, self.mid)
        self.text4= wx.TextCtrl(self, -1,  self.max)
        self.text5 = wx.TextCtrl(self, -1, spaceg)
        self.text6 = wx.TextCtrl(self, -1, self.hydrogen)
 
        
        self.combo_box_1 = wx.ComboBox(self, -1, self.lastposition1, choices=["'White'", "'Green'", "'Red'", "'Blue'", "'Yellow'", "'Black'", "'Pink'", "'Purple'", "'Orange'", "'Grey'", "'Aqua'", "'Brown'", "'Colourless'"], style=wx.CB_DROPDOWN)
        self.combo_box_2 =  wx.ComboBox(self, -1, self.lastposition2, choices=listdev, style=wx.CB_DROPDOWN)
        self.text7 = wx.TextCtrl(self, -1,  self.mformula)
        self.text9 = wx.TextCtrl(self, -1, temper)
        self.text10 = wx.TextCtrl(self, -1,  abctmin)
        self.text11 = wx.TextCtrl(self, -1, abctmax)
        self.static_line_3 = wx.StaticLine(self, -1)
        self.OK = wx.Button(self, -1, "OK")
        self.Cancel = wx.Button(self, wx.ID_CANCEL, "Cancel")
        self.Bind(wx.EVT_BUTTON, self.GETV, self.OK)
        self.__set_properties()
        self.__do_layout()
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("Prepare cif file for publication")
        xres,yres= wx.DisplaySize()
        self.SetMinSize((800, 500))
#        size=(displaySize[0]/2, displaySize[1]/2)
        if ossystem.startswith("darwin"):
            self.SetSize((xres/3.1*xres/yres, yres/2))
        else:       
            self.SetSize((xres/3.1*xres/yres, yres/2))
    
        self.SetFocus()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        grid_sizer_2 = wx.GridSizer(1, 3, 0, 0)
        grid_sizer_1 = wx.GridSizer(6, 3, 0, 0)
       # sizer_22 = wx.StaticBoxSizer(self.panel_2, wx.HORIZONTAL) #remove
        sizer_15 = wx.StaticBoxSizer(self.sizer_15_staticbox, wx.HORIZONTAL)
        sizer_14 = wx.StaticBoxSizer(self.sizer_14_staticbox, wx.HORIZONTAL)
        sizer_19 = wx.StaticBoxSizer(self.sizer_19_staticbox, wx.HORIZONTAL)
        sizer_18 = wx.StaticBoxSizer(self.sizer_18_staticbox, wx.HORIZONTAL)
        sizer_17 = wx.StaticBoxSizer(self.sizer_17_staticbox, wx.HORIZONTAL)
        sizer_16 = wx.StaticBoxSizer(self.sizer_16_staticbox, wx.HORIZONTAL)
        sizer_13 = wx.StaticBoxSizer(self.sizer_13_staticbox, wx.HORIZONTAL)
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.HORIZONTAL)
        sizer_11 = wx.StaticBoxSizer(self.sizer_11_staticbox, wx.HORIZONTAL)
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.HORIZONTAL)
        sizer_9 = wx.StaticBoxSizer(self.sizer_9_staticbox, wx.HORIZONTAL)
        sizer_8 = wx.StaticBoxSizer(self.sizer_8_staticbox, wx.HORIZONTAL)
        sizer_7 = wx.StaticBoxSizer(self.sizer_7_staticbox, wx.HORIZONTAL)
        sizer_6 = wx.StaticBoxSizer(self.sizer_6_staticbox, wx.HORIZONTAL)
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.HORIZONTAL)
        sizer_4.Add(self.list_box_1, 1, wx.EXPAND|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_6.Add(self.combo_box_1, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_7.Add(self.text_shape, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_8.Add(self.text1, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_9.Add(self.text2, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_10.Add(self.text3, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_11.Add(self.text4, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_12.Add(self.text5, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_13.Add(self.text6, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_13, 1, wx.EXPAND, 0)
        sizer_16.Add(self.combo_box_2, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_17.Add(self.text7, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_17, 1, wx.EXPAND, 0)
        sizer_18.Add(self.text8, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_18, 1, wx.EXPAND, 0)
        sizer_19.Add(self.text9, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_19, 1, wx.EXPAND, 0)
        
        sizer_14.Add(self.text10, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_15.Add(self.text11, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(sizer_15, 1, wx.EXPAND, 0)
        grid_sizer_1.Add( self.panel_2, 1, wx.EXPAND, 0)
        #grid_sizer_1.Add(self.static_line_3, 0, wx.EXPAND, 0)
        sizer_5.Add(grid_sizer_1, 4, wx.EXPAND, 0)
        grid_sizer_2.Add(self.OK, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add((20, 20), 0, wx.EXPAND, 0)
        grid_sizer_2.Add(self.Cancel, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_5.Add(grid_sizer_2, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_3, 4, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        self.SetSizerAndFit(sizer_1)
        self.Layout()   
              
    def fullspace(self, event):
        sinfo=open(os.path.join(self.path,'user','rinfo.dat'),"r")
        sglines=sinfo.readlines()
        sinfo.close()
        cif=open(self.fnoe+'.pcf',"r")
        cifread=cif.readlines()
        cif.close()
        for line in cifread:
            if line.startswith('_symmetry_space_group_name_H-M'):

                sg=(((line.replace('_symmetry_space_group_name_H-M','')).strip()).replace("(","")).replace(")","")
                if sg=="?":
                    fullgroup="'?'"
                    return fullgroup
                else:
                    for line in sglines:
                        if line.replace(" ","").startswith(sg+':'):
                           part=line.split(':')
                          # printpart[1]
                           fullgroup="'"+part[1].replace('\n','')+"'"
                           return fullgroup
        
    def Device(self, event):
        if os.path.exists(os.path.join(self.path,"user","device",self.device))==True: 
            if not (os.path.join(self.path,"user","device",self.device)).endswith("default.dev"):
                dev=os.path.join(self.path,"user","device",self.device)
                devfile=open(dev,"r").readlines()
                return devfile
            else:
                devfile=[]
                return devfile
        else:
                wx.MessageBox(os.path.join(self.path,"user","device",self.device)+'dev file was not found', 'Error', wx.OK | wx.ICON_INFORMATION)
       
        
    def GETV(self, event):
        global fnoe
        #dict=["_chemical_formula_moiety"]
        listn=[]
        self.selfile=self.list_box_1.GetStringSelection()
        #print "setfile      ", selfile
        self.colour = self.combo_box_1.GetValue()
        self.device = self.combo_box_2.GetValue()
        # print self.device
        self.mformula= "'"+self.text7.GetValue()+"'"
        self.shape= "'"+self.text_shape.GetValue()+"'"
        self.cells="'"+self.text8.GetValue()+"'"
        self.zval = self.text1.GetValue()
       # # printself.zval
        self.temper=self.text9.GetValue()
        self.abctmin=self.text10.GetValue()
        self.abctmax=self.text11.GetValue()
        self.hydrogen=self.text6.GetValue()
#        self.abctmax=self.text11.GetValue()
        self.lastposition1=self.combo_box_1.GetValue()
        self.lastposition2=self.combo_box_2.GetValue()
        listbsel=(str(self.list_box_1.GetSelections())).replace("(","").replace(")","").replace(",","")
       # # print"lastposition ", self.lastposition1, self.lastposition2
        lintmp=open(os.path.join(self.dirname,"lin.tmp"), 'w')
        lintmp.writelines(self.lastposition1+'\n' + self.lastposition2+"\n"+str(listbsel))
        lintmp.close()
        
        self.spaceg=self.text5.GetValue()
        x = self.text2.GetValue()
        y = self.text3.GetValue()
        z = self.text4.GetValue()
        self.fullg=self.fullspace(event)
       # # printself.fullg
        listn.insert(1, x)
        listn.insert(1, y)
        listn.insert(1, z)
        listn.sort()
        self.min=listn[0]
        self.mid=listn[1]
        self.max=listn[2]
       # # print"text", self.cells, self.mformula, self.zval,self.min,self.mid,self.max
        self.Close(True)
        self.getPrepared(event)    
        publ = wx.MessageDialog( self, "Do you want to check publish.cif", "publish.cif ...", wx.YES_NO)
        igot = publ.ShowModal() # shows it
        if igot == wx.ID_YES:
            webbrowser.open("http://journals.iucr.org/services/cif/checkcif.html")
    def pcfupdate(self, event):
        self.pcfr_dict["_symmetry_cell_setting"]=self.cells
        self.pcfr_dict["_cell_formula_units_Z"]=self.zval
        self.pcfr_dict["_exptl_crystal_colour"]=self.colour
        self.pcfr_dict["_chemical_formula_moiety"]=self.mformula
        self.pcfr_dict["_exptl_crystal_size_min"]=self.min
        self.pcfr_dict["_exptl_crystal_size_mid"]=self.mid
        self.pcfr_dict["_exptl_crystal_size_max"]=self.max
        self.pcfr_dict["_computing_publication_material"]= "'"+"LinXTL v."+self.version+" (Spasyuk, 2009)"+"'"
        self.pcfr_dict["_exptl_absorpt_correction_T_max"]=self.abctmax
        self.pcfr_dict["_exptl_absorpt_correction_T_min"]=self.abctmin
        self.pcfr_dict["_exptl_absorpt_correction_Type"]="'multi-scan'"
        self.pcfr_dict["_exptl_crystal_density_method"]= "'not measured'"
        self.pcfr_dict["_symmetry_space_group_name_H-M"]=self.spaceg
        self.pcfr_dict["_exptl_crystal_description"]=self.shape
        self.pcfr_dict["_diffrn_ambient_temperature"]=self.temper
        self.pcfr_dict["_refine_ls_hydrogen_treatment"]=self.hydrogen
        self.pcfr_dict["_cell_measurement_temperature"]=self.temper
        return [k+(34-len(k))*" "+v+"\n" for k, v in self.pcfr_dict.items()]
    def getpcfile(self, event):
        pcfopen=open(self.fnoe+".pcf")
        pcflines=pcfopen.readlines()
        pcfopen.close()
        return pcflines
    def updatingpcf(self,event, first, second, loopend="_atom_site_label"):  
        for uplines in second:
            for num, line in enumerate(first):
                if not loopend in line: #limit looping to atom_site_label
                    try:
                        if uplines:
                            if line:
                                if uplines.encode('utf-8').split()[0] in line:
                                    first[num]=uplines
                                if uplines.encode('utf-8').split()[0] in "_chemical_formula_sum":
                                    first[num+1]=uplines
                    except IndexError:
                        pass
                else:                      
                      break
        return first
    def addnotexisting(self, event, list1, list2):
        addedlist=list1
        list1_string=" ".join(list1)
        for items in list2:
            if items.encode('utf-8').split()[0] not in list1_string:
                addedlist.append(items)
        return addedlist
    def getcif(self, event):
        if os.path.exists(self.fnoe+".cif")==True: 
            destin=open(self.fnoe+".cif", 'r').readlines()
            return destin
   
    def fsinsert(self, event, cif):
            for i, item in enumerate(cif):
                if "_symmetry_space_group_name_H-M" in item:
                    ind=i+1
                    cif.insert(ind, "_symmetry_space_group_name_Hall       "+self.fullspace(event))    
                    return cif
    def getPrepared(self, event):
        usertop=open(os.path.join(self.path,'user',self.selfile)).readlines()
        pcflist_updated=self.pcfupdate(event)
        pcflines=self.getpcfile(event)
        pcflines=self.updatingpcf(event, pcflines, pcflist_updated) #update pcf with dialog
        pcflines=self.addnotexisting(event, pcflines,  pcflist_updated) # add items from updeted lines 
        devicelist=self.Device(event)
        ciflist=self.getcif(event)
        updatingcif=self.updatingpcf(event, ciflist, pcflines)
        updatingcif=self.updatingpcf(event, ciflist, devicelist)
        for files in os.listdir(self.dirname):
            if files.endswith("sq.fab"):
                    mes = wx.MessageDialog( self, "Squeeze data was found. Use ABIN instruction in the res file to add it", "Squeeze data found", wx.OK | wx.ICON_INFORMATION)
                    igot = mes.ShowModal() # Shows it
                    break    
        fulldestin=usertop+updatingcif
        destin=open("publish.cif", 'w').writelines(fulldestin)
        pcfsave=open(self.fnoe+'.pcf',"w")
        pcfread=pcfsave.writelines(pcflines)
        pcfsave.close()