#!/usr/bin/env python
# -*- coding: utf-8 -*-
#Boa:Frame:frm
#----------------------------------------------------------------------------
# Name:         ui_frm_main.py (module of Molecular View software)
# Purpose:      Molecular View is a software for the visualization of PDB 
#               files and can be used for the generation of correspondent 
#               VRML or STL files, for Rapid Prototyping purposes.
#
# Authors:      Tatiana Al-Chueyr Pereira Martins,
#               Paulo Henrique Junqueira Amorim,
#               Felipe Faria de Souza
#
# Created:      October 2007
# Copyright:    (c) 2007 by Tatiana Al-Chueyr Pereira Martins
# Licence:      General Public License 2 (GPL2)
#----------------------------------------------------------------------------
from __future__ import print_function
import os
import wx
import sys

#import wx.gizmos
#from vtk import vtkCamera
#camera =vtkCamera ();
#camera.ParallelProjectionOn();
def create(parent):
    return frm(parent)
ID_FRM=1
ID_FRMPANEL=2
ID_OPENFILE=3
ID_FULLSCREEN=4
ID_LICENSE=5
ID_ABOUT=6
ID_EXIT=7
ID_CLOSEFILE=8
ID_ABOUT=9
ID_EXPORTFILE=10
inputfile=sys.argv

class frm(wx.Frame):
    def _init_sizers(self):
        # generated method, don't edit
        self.filename=''
        self.boxsizer = wx.BoxSizer(orient=wx.HORIZONTAL)
        self._init_coll_boxsizer_Items(self.boxsizer)
        self.SetSizer(self.boxsizer)
        if len(inputfile)==2:
           self.filename=inputfile[1]
           self.open_file(self.filename)
  
    def _init_coll_boxsizer_Items(self, parent):
        # generated method, don't edit
        parent.AddWindow(self.panel, 1, border=0, flag=wx.GROW | wx.EXPAND)

    def _init_coll_menubar_Menus(self, parent):
        parent.Append(menu=self.menu_file, title='File')
        parent.Append(menu=self.menu_help, title='Help')

    def _init_utils(self):
        # generated method, don't edit
        self.menubar = wx.MenuBar()
        self.menubar.SetAutoLayout(True)
        self.menu_file = wx.Menu(title='')
        self.menu_view = wx.Menu(title='')
        self.submenu_stereo = wx.Menu(title='')
        self.menu_help = wx.Menu(title='')
        self._init_coll_menubar_Menus(self.menubar)
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Frame.__init__(self, id=ID_FRM, name='Elix', parent=prnt, pos=wx.Point(0, 0), size=wx.Size(1000, 700), style=wx.DEFAULT_FRAME_STYLE, title='Elix')
        self._init_utils()
        self.SetMenuBar(self.menubar)
        self.panel = wx.Panel(id=ID_FRMPANEL, name='panel', parent=self, pos=wx.Point(0, 0), size=wx.Size(992, 666),style=wx.TAB_TRAVERSAL)
        self.panel.SetBackgroundColour(wx.Colour(128, 128, 128))
        self._init_sizers()

    def __init__(self, parent):
        from controller import controller
        self.controller = controller(self)
        self._init_ctrls(parent)        
        self._init_menu_file(self.menu_file)
        self._init_menu_view(self.menu_view)
        self._init_menu_help(self.menu_help)
        self.init_evt()
        self.Center()
        self.fullscreen_on = 0

    def _init_menu_file(self, parent):
        item = wx.MenuItem(parent, ID_OPENFILE,'Open...', 'Open PDB file')
        parent.AppendItem(item)
        item = wx.MenuItem(parent, ID_EXPORTFILE,'Export...', 'Export file')
        parent.AppendItem(item)
        item = wx.MenuItem(parent, ID_CLOSEFILE,  'Close', 'Close file')
        parent.AppendItem(item)
#        item = wx.MenuItem(parent,ID_EXIT, 'Exit Molecular View', 'Exit Molecular View')
#        parent.AppendItem(item)

    def _init_menu_help(self, parent):
#        item = wx.MenuItem(parent, ID_LICENSE,'License', 'Software license')
#        parent.AppendItem(item)
        item = wx.MenuItem(parent, ID_ABOUT,'About Elix', 'About Molecular View')
#        item.SetBitmap(wx.Bitmap(os.path.abspath('../img/molecule.gif'), wx.BITMAP_TYPE_GIF))
        parent.AppendItem(item)
    def _init_menu_view(self, parent):
        
        item = wx.MenuItem(parent, ID_FULLSCREEN,
                           'Fullscreen\tV', 'Show main panel in fullscreen mode')
        parent.AppendItem(item)
        parent.AppendSeparator()
        
#        parent.AppendMenu(help='Stereo mode', id=wxID_FRMMENU_VIEWITEM_STEREOMODE,
#                            submenu=self.submenu_stereo, text='Stereo mode')
    
#    def _init_submenu_view_stereo(self, parent):
#        parent.Append(help='', id=wxID_FRMSUBMENU_VIEWITEM_STEREOOFF, kind=wx.ITEM_RADIO, text='Off')
#        parent.Append(help='', id=wxID_FRMSUBMENU_VIEWITEM_STEREOCRYSTALEYES, kind=wx.ITEM_RADIO, text='CrystalEyes')
#        parent.Append(help='', id=wxID_FRMSUBMENU_VIEWITEM_STEREOINTERLACED, kind=wx.ITEM_RADIO, text='Interlaced')
#        parent.Append(help='', id=wxID_FRMSUBMENU_VIEWITEM_STEREOREDBLUE, kind=wx.ITEM_RADIO, text='RedBlue')
#        parent.Append(help='', id=wxID_FRMSUBMENU_VIEWITEM_STEREOLEFT,
#              kind=wx.ITEM_RADIO, text='Left')
#        parent.Append(help='', id=wxID_FRMSUBMENU_VIEWITEM_STEREORIGHT,
#              kind=wx.ITEM_RADIO, text='Right')
#        parent.Append(help='', id=wxID_FRMSUBMENU_VIEWITEM_STEREODRESDEN,
#              kind=wx.ITEM_RADIO, text='Dresden')
#                
    def init_evt(self):
        self.Bind(wx.EVT_SIZE, self.resize)  
        self.Bind(wx.EVT_MENU, self.open_file, id=ID_OPENFILE)
        self.Bind(wx.EVT_MENU, self.exit, id=ID_EXIT)
        self.Bind(wx.EVT_MENU, self.close_file, id=ID_CLOSEFILE)
        self.Bind(wx.EVT_MENU, self.export_file, id=ID_EXPORTFILE)
        self.Bind(wx.EVT_MENU, self.show_about, id=ID_ABOUT)
        self.Bind(wx.EVT_MENU, self.show_license, id=ID_LICENSE)
        
#        self.Bind(wx.EVT_RIGHT_DOWN, self._OnButtonDown)
#        self.Bind(wx.EVT_LEFT_DOWN, self._OnButtonDown)
#        self.Bind(wx.EVT_MIDDLE_DOWN, self._OnButtonDown)
#        self.Bind(wx.EVT_RIGHT_UP, self._OnButtonUp)
#        self.Bind(wx.EVT_LEFT_UP, self._OnButtonUp)
#        self.Bind(wx.EVT_MIDDLE_UP, self._OnButtonUp)
#        self.Bind(wx.EVT_MOTION, self.OnMotion)
#        self.Bind(wx.EVT_MENU, self.set_fullscreen_mode, id=wxID_FRMMENU_VIEWITEM_FULLSCREEN)
#        self.Bind(wx.EVT_MENU, lambda e, s = self:self.set_stereo_mode(e, 0), id=wxID_FRMSUBMENU_VIEWITEM_STEREOOFF)    
#        self.Bind(wx.EVT_MENU, lambda e, s = self:self.set_stereo_mode(e, 1, 'CrystalEyes'), id=wxID_FRMSUBMENU_VIEWITEM_STEREOCRYSTALEYES)
#        self.Bind(wx.EVT_MENU, lambda e, s = self:self.set_stereo_mode(e, 1, 'RedBlue'), id=wxID_FRMSUBMENU_VIEWITEM_STEREOREDBLUE)      
#        self.Bind(wx.EVT_MENU, lambda e, s = self:self.set_stereo_mode(e, 1, 'Interlaced'), id=wxID_FRMSUBMENU_VIEWITEM_STEREOINTERLACED)
#        self.Bind(wx.EVT_MENU, lambda e, s = self:self.set_stereo_mode(e, 1, 'Left'), id=wxID_FRMSUBMENU_VIEWITEM_STEREOLEFT)
#        self.Bind(wx.EVT_MENU, lambda e, s = self:self.set_stereo_mode(e, 1, 'Right'), id=wxID_FRMSUBMENU_VIEWITEM_STEREORIGHT)     
#        self.Bind(wx.EVT_MENU, lambda e, s = self:self.set_stereo_mode(e, 1, 'Dresden'), id=wxID_FRMSUBMENU_VIEWITEM_STEREODRESDEN)

        
    def resize(self, event):
        self.Layout()
        self.controller.resize_ui(self.panel.GetSize())
        event.Skip()
    
    def get_data_panel(self):
        return self.panel
    
    def open_file(self, fileame):
        
        if not self.filename:
      
            self.controller.open_file('')
        else: 
             f=self.filename
             self.controller.open_file(f)
        

    def show_about(self, event):
        self.controller.show_about_dlg()
        event.Skip()

    def set_header(self, filename=""):
        if filename:
            self.SetTitle(filename+' - Elix')
        else:
            self.SetTitle('Elix')

    def exit(self, event):
        self.controller.exit()
        self.Close()
        event.Skip()

    def close_file(self, event):
        self.controller.close_file()
        event.Skip()

    def export_file(self, event):
        self.controller.export_file()
        event.Skip()

    def show_license(self, event):
        self.controller.show_license()
        event.Skip()
    
    def set_stereo_mode(self, event, on=True, mode='RedBlue'):
        self.controller.set_stereo_mode(on, mode)
        event.Skip()
        
    def set_fullscreen_mode(self, event=None, on=True):
        import sys
        if sys.platform == 'win32':
            self.fullscreen_on = not self.fullscreen_on
        elif sys.platform == 'linux2':
            self.fullscreen_on = on
        else:
            print ("Check OS behaviour to determine how fullscreen will work on ui_frm_main") 
        
        self.ShowFullScreen(self.fullscreen_on)
        if event:
            self.controller.set_viewer_fullscreen()
            event.Skip()


class BoaApp(wx.App):
    def OnInit(self):
        frame_1 = frm(None)
        self.SetTopWindow(frame_1)
        frame_1.Show(True)
        return 1
# end of class MyApp

if __name__ == "__main__":
    #app = MyApp(redirect=True,  filename='log')
    app = BoaApp(0)
    app.MainLoop()
